

// program launcher


#include "mainwin.h"
#include "resource.h"


/////////////////////////////////////////////////////////////////////////////

void GetVersionString
  (PMAINWINCTX pCtx)
{
  DWORD             dwZero;
  DWORD             dwInfoSize;
  UINT              uLen;
  void*             pInfo;
  VS_FIXEDFILEINFO* pVffi;

  GetModuleFileName(GetModuleHandle(NULL), 
                    pCtx->szExeName, 
                    sizeof(pCtx->szExeName));

  dwInfoSize = GetFileVersionInfoSize(pCtx->szExeName, &dwZero);

  pInfo = (void*) LocalAlloc(LMEM_FIXED, dwInfoSize);

  GetFileVersionInfo(pCtx->szExeName, 
                     0, 
                     dwInfoSize, 
                     pInfo);

  VerQueryValue(pInfo,
                "\\",
                (void**) &pVffi,
                &uLen);

  wsprintf(pCtx->szVersion, 
           "%d.%02d.%02d.%03d",
           pVffi->dwFileVersionMS >> 16,
           pVffi->dwFileVersionMS & 0x0ffff,
           pVffi->dwFileVersionLS >> 16,
           pVffi->dwFileVersionLS & 0x0ffff);

  LocalFree((HLOCAL) pInfo);
}


/////////////////////////////////////////////////////////////////////////////


int WINAPI WinMain
  (HINSTANCE hInst,
   HINSTANCE hPrevInstance, 
   PSTR szCmdLine,
   int nCmdShow) 
{
  PMAINWINCTX pCtx;
  HWND        hWnd;
  MSG         msg;
  HACCEL      hAccel;

  if (!MainWin_Init(hInst)) 
  {
    return 0;
  }

  if (NULL == (pCtx = MainWin_Create(hInst))) 
  {
    return 0;
  }

  GetVersionString(pCtx);

  hWnd = MainWin_GetHandle(pCtx);

  ShowWindow(hWnd, nCmdShow);
 
  UpdateWindow(hWnd);

  hAccel = LoadAccelerators(hInst, MAKEINTRESOURCE(IDR_ACC_MAINWIN));

  // handle command line stuff
  if (lstrlen(szCmdLine)) 
  {
    MainWin_ExecFileHash(pCtx, szCmdLine);
  }

  while (GetMessage(&msg, NULL, 0, 0)) 
  {
    if (!TranslateAccelerator(hWnd, hAccel, &msg)) 
    { 
      TranslateMessage(&msg);
      DispatchMessage(&msg);
    }
  }

  MainWin_Destroy(pCtx);

  return (int)msg.wParam;
}
